#include <iostream>
#include <bits/stdc++.h>

using namespace std;

/*7
1 7 2 7 2 2 3
4
1 4
2 7
4 6
3 7*/

int main()
{
   long long int q,n,jegyez=-1,osszeg;
   bool kj=true;
cin>>n;
vector<long long int> ertek,eredmeny;
for(long long int i=0;i<n;i++)
{
    long long int a;
    cin>>a;
    if(a>2)
    {
        kj=false;
    }
    if(a<jegyez)
    {
        osszeg++;
    }
    ertek.push_back(osszeg);
    jegyez=a;
}
cin>>q;
while(kj){}
for(long long int i=0;i<q;i++)
{
long long int a,b;
cin>>a>>b;

    if(ertek[b-1]-ertek[a-1]<2)
    {
        eredmeny.push_back(1);
    }
    else
    {
        eredmeny.push_back(0);
    }


}
for(long long int i=0;i<eredmeny.size();i++)
{
    if(eredmeny[i]==1)
    {
        cout<<"DA"<<endl;
    }
    else
    {
        cout<<"NE"<<endl;
    }
}
}